strapper/access/urls.py
# pylint:
from django.urls import path
from . import views

app_name = 'access'

urlpatterns = [
    path('search_users/', views.UserAPIView.as_view(), name='search_users'),
    path('update_app_access/', views.AccessAPIView.as_view(), name='update_app_access'),
    path(
        'email_ownership_transfer_request/',
        views.AccessAPIView.as_view(),
        name='email_ownership_transfer_request'),
    path(
        'accept_ownership_transfer_request/<slug:app_id>/',
        views.TransferOwnershipAPIView.as_view(),
        name='accept_ownership_transfer_request'),
    path(
        'cancel_ownership_transfer_request/<slug:app_id>/',
        views.TransferOwnershipAPIView.as_view(),
        name='cancel_ownership_transfer_request'),
    path(
        'decline_ownership_transfer_request/<slug:app_id>/',
        views.TransferOwnershipAPIView.as_view(),
        name='decline_ownership_transfer_request'),
]

strapper/help/urls.py
# pylint:
from django.urls import path
from . import views

urlpatterns = [
    path('using_strapper', views.UsingStrapperPage.as_view(), name="help_using_strapper"),
    path('about_strap/', views.AboutStrapPage.as_view(), name="help_about_strap"),
]

strapper/strapper/urls.py
# pylint:
"""strapper URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from . import auth

urlpatterns = [
    path('admin-django/', admin.site.urls),
    path('login/', auth.LoginView.as_view(), name='login'),
    path('logout/', auth.LogoutView.as_view(), name='logout'),
    path('admin/', include('admin_users.urls'), name='admin_users'),
    path('content/', include('django_editablecontent.urls'), name='editablecontent'),
    path('fileupload/', include('django_fileupload.urls'), name='fileupload'),
    path('help/', include('help.urls'), name='help'),
    path('wizard/', include('wizard.urls'), name='wizard'),
    path('access/', include('access.urls'), name='access'),
    path('', include('normal_users.urls'), name='normal_users'),
]

# Add URL patterns for serving media files during development
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

strapper/normal_users/models.py
# pylint: disable=invalid-sequence-index,too-many-ancestors
#   invalid-sequence-index: sequence index is a Django model
#   IntegerField, which is an int
#   too-many-ancestors: inheriting from Django's model classes
#   and we have no control over ancestors or depth of inheritance

import os
from typing import Dict, List
import json
import time
import shlex
import re
from urllib.parse import quote_plus as urlencode, urlparse
import requests

from kubernetes import client, config as kube_config, stream

from django.db import models
from django.core import validators
from django.contrib.auth.models import User
from django.conf import settings

from admin_users.models import GeneralConfig, HarborConfig

class AuthTypes(models.TextChoices):
    UVIC = 'uvic', 'Uvic'
    UVIC_SOCIAL = 'uvic_social', 'Uvic + Social'

class DatabaseTypes(models.TextChoices):
    NONE = 'None', 'None'
    POSTGRESQL = 'PostgreSQL', 'PostgreSQL'
    MYSQL = 'MySQL', 'MySQL'

# An application configuration created by users
class Application(models.Model):
    identifier = models.CharField(max_length=16, primary_key=True)
    descriptive_name = models.CharField(max_length=100, null=False, blank=False)
    description = models.CharField(max_length=500, blank=True, default="")
    authentication = models.CharField(max_length=15, choices=AuthTypes.choices,
        null=True, blank=True)
    database = models.CharField(max_length=20, choices=DatabaseTypes.choices, default=DatabaseTypes.NONE, blank=True)
    port = models.IntegerField(null=True, blank=True,
        validators = [validators.MinValueValidator(0), validators.MaxValueValidator(65536)])
    is_secure = models.BooleanField(default=False)
    published_on_strap = models.BooleanField(default=False)
    replicas = models.IntegerField(null=False, blank=False, default=1)
    owner = models.ForeignKey(User, on_delete=models.CASCADE)
    last_updated = models.DateTimeField(auto_now=True)

    # Empty means all IPs are allowed. IPs are stored as a comma-separated list
    allowed_ips = models.CharField(max_length=300, null=True, blank=True)

    # Exempt from blocking in case vulnerability scan shows vulnerabilities
    # above threshold
    vuln_blocking_exempt = models.BooleanField(default=False)

    class Meta:
        db_table = 'application'
        ordering = ['-last_updated']

    def save(self, *args, **kwargs):
        """
        Ensure an app always has 2 role groups - editor and viewer
        """
        super().save(*args, **kwargs)

        # Create role groups if they don't exist
        if not self.approlegroup_set.filter(role='editor').exists():
            self.approlegroup_set.create(role='editor')
        if not self.approlegroup_set.filter(role='viewer').exists():
            self.approlegroup_set.create(role='viewer')

        # Create a quota if it doesn't exist
        if not ApplicationQuota.objects.filter(application=self).exists():
            ApplicationQuota.objects.create(application=self)

        # Create a quota request, set to None state if it doesn't exist
        if not hasattr(self, 'applicationquotarequest'):
            ApplicationQuotaRequest.objects.create(application=self)

    def delete(self, *args, **kwargs):
        """
        Delete all role groups of the app before deleting the app
        """
        for group in self.approlegroup_set.all():
            group.delete()
        super().delete(*args, **kwargs)

    def __repr__(self):
        return self.descriptive_name

    def is_deployable(self):
        """
        Determine if applition is deployable. An app is deployable if:
        - Its containers have no vulnerabilities higher than the threshold OR
          it is exempt from blocking due to vulnerabilities found
        - It has at least one container
        - It has a port, meaning it has a main container
        """
        return ((self.is_secure or self.vuln_blocking_exempt)
                and self.port and self.container_set.count() > 0)

    # Check if the app has a certain route
    def has_route(self, route):
        return self.route_set.filter(route=route).exists()

    def create_routes(self, route_list, authenticated=True):
        """
        Create routes (if not exist already) for the application
        Args:
            - route_list: list of routes (str) to create (might already exist)
            - authenticated: boolean, True if the routes are authenticated, False otherwise
        Returns: None
        """
        for route in route_list:
            if route and not self.has_route(route):
                if not route.startswith('/'):
                    route = '/' + route
                self.route_set.create(route=route, authenticated=authenticated)

    # Convert all routes (authenticated or unauthenticated) into a string
    # where routes are separated by a comma ','
    def routes_to_str(self, authenticated=True):
        return ','.join(route.route for route in list(self.route_set.filter(authenticated=authenticated)))

    # Similar to routes_to_str but only return authenticated routes
    # NOTE: Must keep this method to be used in Django templates
    def authenticated_routes_to_str(self):
        return self.routes_to_str(authenticated=True)

    # Similar to routes_to_str but only return unauthenticated routes
    # NOTE: Must keep this method to be used in Django templates
    def unauthenticated_routes_to_str(self):
        return self.routes_to_str(authenticated=False)

    # Returns a dictionary of allowed IPs separated by categories
    # Key: either a preset name or "others"
    # Value: a list of IPs
    def get_allowed_ips(self) -> Dict[str, List[str]]:
        if not self.allowed_ips:
            return {}

        allowed_ips = {}
        general_config = GeneralConfig.get_instance()
        preset_ips = general_config.get_preset_ips()
        for name in preset_ips.keys():
            if set(preset_ips[name]).issubset(self.allowed_ips.split(',')):
                allowed_ips[name] = preset_ips[name]

        # Combine all preset IPs into a list
        preset_ips_list = [ip for ips in preset_ips.values() for ip in ips]
        other_ips = [ip for ip in self.allowed_ips.split(',') if ip not in preset_ips_list]
        if len(other_ips):
            allowed_ips['others'] = other_ips
        return allowed_ips

    # Returns True if app has an advanced config set, False otherwise
    def has_advanced_config(self) -> bool:
        advanced_config = False
        if self.allowed_ips:
            advanced_config = True

        return advanced_config

    # Convert app configurations into a dictionary
    def build_configuration(self):
        tfvars = {}

        # General configurations
        tfvars['app_name'] = self.identifier
        tfvars['app_port'] = self.port if self.port else 80
        tfvars['authentication'] = self.authentication
        tfvars['authenticated_routes'] = (
            self.routes_to_str(authenticated=True).split(',')
            if len(self.route_set.filter(authenticated=True)) > 0
            else None
        )
        tfvars['unauthenticated_routes'] = (
            self.routes_to_str(authenticated=False).split(',')
            if len(self.route_set.filter(authenticated=False)) > 0
            else None
        )
        tfvars['database'] = self.database if self.database != 'None' else None
        tfvars['allowed_ips'] = self.allowed_ips.split(',') if self.allowed_ips else []
        tfvars['replicas'] = self.replicas

        # Containers
        containers = []
        for container in self.container_set.all():
            env_vars = container.get_environment_variables()
            container_dict = {
                'image': container.image,
                'tag': container.image_tag,
                'port': container.port if container.port else 80,
                'command': shlex.split(container.command) if container.command else None,
                'environment': env_vars if len(env_vars) != 0 else None,
                'shared_volume_path': "/tmp/mnt_shared_volume"
            }
            containers.append(container_dict)
        tfvars['containers'] = containers
        tfvars['image_credentials'] = (
            self.harborproject.build_image_credentials()
            if hasattr(self, 'harborproject')
            else None
        )

        # TODO: Fix this when adding Harbor
        tfvars['deploy'] = True

        return tfvars

    def detect_config_change(self):
        '''
        Check if there is any change made in the app configuration comparing to
        configurations used in the most recent deployment
        Returns: boolean
        - True: there is
        - False: there isn't
        '''
        # If there is no successful deployment for this app,
        # return True
        try:
            k8sinstance = self.k8sinstance
        except K8sInstance.DoesNotExist:
            return True

        # Check if there is any change in app container configurations
        containers_ids = []
        for k8scontainer in k8sinstance.k8scontainer_set.all():
            try:
                container = k8scontainer.container
            except Container.DoesNotExist:
                return True

            if not container or container.application != self:
                return True

            if (container.image != k8scontainer.image or container.image_tag != k8scontainer.image_tag
                or container.port != k8scontainer.port or container.command != k8scontainer.command
                or container.environment_variables != k8scontainer.environment_variables):
                return True

            containers_ids.append(container.id)

        # Check if there is any container that is not in the most recent deployment
        for container in self.container_set.all():
            if container.id not in containers_ids:
                return True

        # Check if there is any change in app configurations

strapper/templates/components/access_manager.html
<div class="app-modal access-manager-panel">
  <div class="app-modal-header bg-dark">Access manager</div>
  <div class="app-modal-body">
    <!-- Owner -->
    <label class="form-label fw-semibold">Owner: <i class="fa-solid fa-circle-info ms-2 role-instructions-btn" data-bs-toggle="modal" data-bs-target="#roleInstructionsModal"></i></label>
    {% if transfer_request and user_role == 'owner' %}
      <div class="alert alert-warning mb-2" role="alert">
        <i class="fa-solid fa-triangle-exclamation me-1"></i>
        There is a pending ownership transfer request for {{ application.descriptive_name }} to <strong>{{ transfer_request.receiver.username }}</strong>.
        This request will expire in {{ transfer_request.days_left }} days.
        <div>
          <a href="{% url 'access:cancel_ownership_transfer_request' app_id=application.identifier %}?active_tab=manage" class="btn btn-warning btn-sm mt-2">Cancel transfer</a>
        </div>
      </div>
    {% endif %}
    <div class="user-card">
      <div>
        <img src="{{ application.owner.profile.get_image }}" width="40" height="40" class="rounded-circle" alt="profile image">
      </div>
      <div class="flex-grow-1">
        <div class="fw-semibold">{% if application.owner.first_name %}{{ application.owner.first_name }} {{ application.owner.last_name }}{% else %}{{ application.owner.username }}{% endif %}</div>
        <div class="text-black-50">{{ application.owner.username }}</div>
      </div>
    </div>

    <!-- Editors -->
    <label class="form-label fw-semibold mt-4">Editors: <i class="fa-solid fa-circle-info ms-2 role-instructions-btn" data-bs-toggle="modal" data-bs-target="#roleInstructionsModal"></i></label>
    {% if editors|length > 0 %}
      <div class="d-flex flex-row align-items-center gap-2 flex-wrap">
        {% for editor in editors %}
          <div class="user-card">
            <div>
              <img src="{{ editor.profile.get_image }}" width="40" height="40" class="rounded-circle" alt="profile image">
            </div>
            <div class="flex-grow-1">
              <div class="fw-semibold">{% if editor.first_name %}{{ editor.first_name }} {{ editor.last_name }}{% else %}{{ editor.username }}{% endif %}</div>
              <div class="text-black-50">{{ editor.username }}</div>
            </div>
          </div>
        {% endfor %}
      </div>
    {% else %}
      <p class="text-black-50">No editors</p>
    {% endif %}

    <!-- Viewers -->
    <label class="form-label fw-semibold mt-4">Viewers: <i class="fa-solid fa-circle-info ms-2 role-instructions-btn" data-bs-toggle="modal" data-bs-target="#roleInstructionsModal"></i></label>
    {% if viewers|length > 0 %}
      <div class="d-flex flex-row gap-2 flex-wrap">
        {% for viewer in viewers %}
          <div class="user-card">
            <div>
              <img src="{{ viewer.profile.get_image }}" width="40" height="40" class="rounded-circle" alt="profile image">
            </div>
            <div class="flex-grow-1">
              <div class="fw-semibold">{% if viewer.first_name %}{{ viewer.first_name }} {{ viewer.last_name }}{% else %}{{ viewer.username }}{% endif %}</div>
              <div class="text-black-50">{{ viewer.username }}</div>
            </div>
          </div>
        {% endfor %}
      </div>
    {% else %}
      <p class="text-black-50">No viewers</p>
    {% endif %}

    {% if user_role == 'owner' %}
      <!-- Access manager modal -->
      {% include 'modals/rolegroup_manager.html' %}

      <!-- Modal warning user about the consequences of ownership transferring action -->
      {% include 'modals/transfer_ownership_warning.html' %}
    {% endif %}

    {% if user_role == 'owner' %}
      <div class="app-modal-btn-container mt-5">
        <button type="button" class="btn btn-outline-primary btn-sm" data-bs-toggle="modal" data-bs-target="#accessManagerModal">Edit</button>
      </div>
    {% endif %}
  </div>
</div>

strapper/templates/components/all_apps_display.html
<div class="app-modal">
  <div class="app-modal-header bg-dark d-flex flex-row justify-content-between"><span>Applications</span><span><i class="fa-solid fa-plus fw-light icon-btn-light app-create-btn"></i></span></div>
  <div class="app-modal-body">
    <div class="card my-2 app-create-form">
      <div class="card-body">
        {% include 'forms/config_app.html' %}
      </div>
    </div>
    {% if owned_applications|length == 0 %}
      <p class="text-center mt-1">No application found. Create one by clicking on the "+" button on the top right corner!</p>
    {% else %}
      {% for application in owned_applications %}
        {% include "cards/application.html" %}
      {% endfor %}
    {% endif %}
  </div>
</div>

strapper/templates/components/app_deployment.html
<div class="app-modal deploy-modal-{{ application.identifier }}">
  <div class="app-modal-header bg-dark">Application Status</div>
  <div class="deploy-alert alert alert-success deploy-alert-success-{{ application.identifier }}" role="alert"></div>
  <div class="deploy-alert alert alert-danger deploy-alert-error-{{ application.identifier }}" role="alert"></div>
  <div class="deploy-alert alert alert-info deploy-alert-info-{{ application.identifier }}" role="alert"></div>
  <div class="app-modal-body">
    <div class="row mb-2">
      <div class="col-5 fw-semibold">State</div>
      <div class="col-7 deploy-state-{{ application.identifier }}">{% if application.deployment %}{{ application.deployment.get_state }}{% endif %}</div>
    </div>
    <div class="row mb-2">
      <div class="col-5 fw-semibold">Status</div>
      <div class="col-7 deploy-status-{{ application.identifier }}">{% if application.deployment %}{{ application.deployment.get_status }}{% endif %}</div>
    </div>

    {% if user_role == 'owner' or user_role == 'editor' %}
      <div class="row mb-2">
        <div class="col-5 fw-semibold">Databases</div>
        <div class="col-7 deploy-databases-{{ application.identifier }}">{% if application.deployment %}{{ application.deployment.databases }}{% endif %}</div>
      </div>
      <div class="row mb-2">
        <div class="col-5 fw-semibold">DB owner</div>
        <div class="col-7 deploy-dbowner-{{ application.identifier }}">{% if application.deployment %}{{ application.deployment.db_owner }}{% endif %}</div>
      </div>
      <div class="row mb-2">
        <div class="col-5 fw-semibold">Initial DB password</div>
        <div class="col-7 deploy-dbpassword-{{ application.identifier }}">
          {% if application.deployment %}
            {% if application.deployment.db_password %}
              <span class="password-display">
                <div class="password">****************</div>
                <pre class="text d-none"><code>{{ application.deployment.db_password }}</code></pre>
                <div class="show-btn">Show</div>
              </span>
            {% else %}
              None
            {% endif %}
          {% endif %}
        </div>
      </div>
    {% endif %}

    <div class="row mb-2">
      <div class="col-5 fw-semibold">Application URL</div>
      <div class="col-7 app-url-{{ application.identifier }}">{% if not application.deployment.state == 2 %}None{% else %}<a href="{{ application.get_url }}" target="_blank">{{ application.get_url }}</a>{% endif %}</div>
    </div>
    <div class="row mb-2">
      <div class="col-5 fw-semibold">Deployment logs</div>
      <div class="col-7 deploy-log-{{ application.identifier }}">{% if not application.deployment %}None{% else %}<a href="/deploy_log/{{application.identifier}}" target="_blank">View</a>{% endif %}</div>
    </div>
    <div class="row mb-2">
      <div class="col-5 fw-semibold">Application logs</div>
      <div class="col-7 app-log-{{ application.identifier }}">{% if application.deployment.state == 2 %}<a href="/app_log/{{application.identifier}}" target="_blank">View</a>{% else %}None{% endif %}</div>
    </div>
    <div class="row mb-2">
      <div class="col-5 fw-semibold">Terminal</div>
      <div class="col-7 terminal-{{ application.identifier }}">{% if application.deployment.state == 2 %}<a href="/terminal/{{application.identifier}}" target="_blank">Open</a>{% else %}Unavailable{% endif %}</div>
    </div>

    {% if user_role == 'owner' or user_role == 'editor' %}
      <div class="app-modal-btn-container">
        <button type="button" class="deploy-stop-btn btn btn-outline-danger btn-sm {% if not application.deployment.is_stoppable %}disabled{% endif %} deploy-stop-btn-{{application.identifier}}" data-app-id="{{application.identifier}}">{% if application.deployment.state == 2 %}Stop{% elif application.deployment.state == 1 or application.deployment.state == 5 %}Cancel{% elif application.deployment.state == 3 or application.deployment.state == 4 %}Destroy{% elif application.deployment.state == 6 %}Revert{% else %}Cancel{% endif %}</button>
        {% if application.deployment.state == 1 %}
          <button type="button" class="deploy-btn btn btn-outline-primary btn-sm disabled deploy-btn-{{application.identifier}}" data-app-id="{{application.identifier}}">
            Deploying...<span class="spinner-border spinner-border-sm text-primary" role="status" aria-hidden="true"></span>
          </button>
        {% elif application.deployment.state == 2 %}
          <button type="button" class="deploy-btn btn btn-outline-primary btn-sm deploy-btn-{{application.identifier}} disabled" data-app-id="{{application.identifier}}">Update</button>
        {% elif application.deployment.state == 6 %}
          <button type="button" class="deploy-btn btn btn-outline-primary btn-sm deploy-btn-{{application.identifier}} disabled" data-app-id="{{application.identifier}}">Update</button>
        {% elif application.deployment.state == 5 %}
          <button type="button" class="deploy-btn btn btn-outline-primary btn-sm disabled deploy-btn-{{application.identifier}}" data-app-id="{{application.identifier}}">
            Updating...<span class="spinner-border spinner-border-sm text-primary" role="status" aria-hidden="true"></span>
          </button>
        {% else %}
          <button type="button" class="deploy-btn btn btn-outline-primary btn-sm deploy-btn-{{application.identifier}} disabled" data-app-id="{{application.identifier}}">Deploy</button>
        {% endif %}
      </div>
    {% endif %}

        {% comment %} This input is for Javascript to check if this app is deployed {% endcomment %}
    <input class="d-none app-deployed-{{ application.identifier }}" type="checkbox" {% if application.k8sinstance %}checked{% endif %}>
  </div>
</div>

strapper/templates/components/app_groups.html
<div class="app-modal">
  <div class="app-modal-header bg-dark d-flex flex-row justify-content-between"><span>{% if application %}Group manager{% else %}All groups{% endif %}</span><span><i class="fa-solid fa-plus fw-light icon-btn-light app-group-create-form-btn"></i></span></div>
  <div class="app-modal-body">
    {% include "forms/app_group.html" %}
    {% if application %}
      {% if application.group_set.count == 0 %}
        <p class="text-center my-1 group-create-text">There is no group for this app. <span class="link-primary text-decoration-underline cursor-default app-group-create-form-btn">Create one</span> right now!</p>
      {% else %}
        {% for group in application.group_set.all %}
          <div class="group-display">
            {% include "cards/group.html" %}
            {% include "forms/app_group.html" %}
          </div>
        {% endfor %}
      {% endif %}
    {% else %}
      {% if owned_groups|length == 0 %}
        <p class="text-center my-1 group-create-text">You haven't created any group. <span class="link-primary text-decoration-underline cursor-default app-group-create-form-btn">Create one</span> right now!</p>
      {% else %}
        {% for group in owned_groups %}
          <div class="group-display">
            {% include "cards/group.html" %}
            {% include "forms/app_group.html" %}
          </div>
        {% endfor %}
      {% endif %}
    {% endif %}
  </div>
</div>

strapper/templates/components/app_k8s.html
<div class="app-modal k8s-resources-manager" id="k8s-resources-manager-{{ application.identifier }}">
  <div class="app-modal-header bg-dark d-flex flex-row justify-content-between align-items-center">
    <span>K8s resources manager</span>
    {% if user_role == 'owner' or user_role == 'editor' %}
      <button class="btn btn-outline-light btn-sm" data-bs-toggle="modal" data-bs-target="#k8s-resources-request-form-{{ application.identifier }}">+ Request more</button>
    {% endif %}
  </div>
  <div class="app-modal-body info-display">
    {% if application.applicationquotarequest.status == "Pending" %}
      <div class="alert alert-warning d-flex align-items-center" role="alert">
        <i class="fa-solid fa-exclamation rounded-circle bg-warning me-2"></i>
        <div>
          There is a pending request to increase the quota for this app.
        </div>
        {% if user_role == 'owner' or user_role == 'editor' %}
          <button class="btn btn-warning btn-sm ms-auto" data-bs-toggle="modal" data-bs-target="#k8s-resources-request-form-{{ application.identifier }}">Details</button>
        {% endif %}
      </div>
    {% endif %}
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Replicas</div>
      <div class="col-8">{{ application.replicas }}/{{ application.applicationquota.replicas }} max</div>
    </div>

    {% if user_role == 'owner' or user_role == 'editor' %}
      <div class="app-modal-btn-container">
        <button type="button" class="edit-btn btn btn-outline-primary btn-sm {% if application.deployment.state == 1 %}disabled{% endif %}">Edit</button>
      </div>
    {% endif %}
  </div>

  <div class="app-modal-body config-form">
    {% if application.applicationquotarequest.status == "Pending" %}
      <div class="alert alert-warning d-flex align-items-center" role="alert">
        <i class="fa-solid fa-exclamation rounded-circle bg-warning me-2"></i>
        <div>
          There is a pending request to increase the quota for this app.
        </div>
        <button class="btn btn-warning btn-sm ms-auto" data-bs-toggle="modal" data-bs-target="#k8s-resources-request-form-{{ application.identifier }}">Details</button>
      </div>
    {% endif %}
    {% include 'forms/config_k8s.html' %}
  </div>
</div>

strapper/templates/components/app_summary.html
<div class="app-modal app-summary" id="app-summary-{{application.identifier}}" data-app-id="{{application.identifier}}">
  <div class="app-modal-header bg-dark">Application Summary</div>
  <div class="app-modal-body">
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Identifier</div>
      <div class="col-8 app-identifier">{{application.identifier}}</div>
    </div>
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Name</div>
      <div class="col-8 app-name descriptive-name">{{application.descriptive_name}}</div>
    </div>
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Description</div>
      <div class="col-8">{{application.description}}</div>
    </div>
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Authentication</div>
      <div class="col-8 authentication">{{application.get_authentication_display}}</div>
    </div>
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Authenticated routes</div>
      <div class="col-8 route-tag-container authenticated-routes">
        {% for route in application.route_set.all %}
          {% if route.authenticated %}
            <div class="route-tag mt-1">{{route.route}}</div>
          {% endif %}
        {% endfor %}
      </div>
    </div>
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Unauthenticated routes</div>
      <div class="col-8 route-tag-container unauthenticated-routes">
        {% for route in application.route_set.all %}
          {% if not route.authenticated %}
            <div class="route-tag mt-1">{{route.route}}</div>
          {% endif %}
        {% endfor %}
      </div>
    </div>
    <div class="row">
      <div class="col-4 fw-semibold">Database</div>
      <div class="col-8">{{application.database}}</div>
    </div>
    <div class="mb-2 helper-text">Note this value <strong>cannot be changed</strong> once <strong>deployed</strong></div>
    {% if application.allowed_ips %}
      <div class="row mb-2">
        <div class="col-4 fw-semibold">Allowed IPs</div>
        <div class="col-8">
          {% for name, ips in application.get_allowed_ips.items %}
            <pre class="mb-0"><code>{{ name|capfirst }}: {{ ips|join:", " }}</code></pre>
          {% endfor %}
        </div>
      </div>
    {% endif %}
    <div class="row mb-2">
      <div class="col-4 fw-semibold">Last updated</div>
      <div class="col-8">{{application.last_updated}}</div>
    </div>
    {% if user_role == 'owner' or user_role == 'editor' %}
      <div class="app-modal-btn-container">
        <button type="button" class="btn btn-outline-primary btn-sm app-summary-edit-btn {% if application.deployment.state == 1 %}disabled{% endif %}">Edit</button>
      </div>
    {% endif %}
  </div>
</div>